/*

 Gestione color 
 questo sorgente e' parte integrante 
 del Progetto xSudoky.
 Scritto da Max Cavallo 20/Luglio/2007
 ixamit@gmail.com

*/

#include "sudoky.h"
int SudoCellOver(CmdInfo *cmd, int eventtype);

void SetCellBackGroundColor (CmdInfo *cella)
{
	int x,y,b,p;

	y=(int) cella->Name[1]-'0';
	x=(int) cella->Name[2]-'0';
	
	Coordinateyx2Blocco (y,x,&b,&p);

	cella->Bg=(b & 1) ? WX11_ColorLightSmall(WX11_ColorGet(BUTTONBG)) : WX11_ColorLight(WX11_ColorGet(BUTTONBG));

	WX11_ColorBackgroundSet (cella, cella->Bg, cella->Bg);

	WX11_PrintFlush(cella);
}

int SudoNotEvidence ()
{
	int y,x;
	CmdInfo *cella;

	for (y=0;y<SUD_TAB;y++)
	{
		for (x=0;x<SUD_TAB;x++)
		{
			if (IsEvidence(y,x))
			{
				sprintf (BUFF,"X%d%d",y,x);
				cella=CercaNomeComando (BUFF);

				SetCellBackGroundColor (cella);	

				if (IsMouseOver (y,x))	SudoCellOver(cella, EnterNotify);

			}
		}
	}
	//
	EVIDENCE=0;
	//
	return (0);
}

int EvidenziaCandidati()
{
	int x,y;
	CmdInfo *cella;

	for (y=0;y<SUD_TAB;y++)
	{
		for (x=0;x<SUD_TAB;x++)
		{
			if (IsEvidence(y,x))
			{
				sprintf (BUFF,"X%d%d",y,x);
				cella=CercaNomeComando (BUFF);
				cella->Bg=EVIDENCE_BG;

				WX11_ColorBackgroundSet (cella, EVIDENCE_BG, EVIDENCE_BG);
				WX11_PrintFlush(cella);

				if (IsMouseOver (y,x))	SudoCellOver(cella, EnterNotify);
			}
		}
	}
	return (0);
}

int SudoEvidence (CmdInfo *cella)
{
	CmdInfo *cmd;
	int Candidato;
        int l=strlen(cella->Label);

	cella->BUpDn=!cella->BUpDn;
	WX11_PrintFlush (cella);

	Candidato=(cella->Label[l-1])-'0';

	if (EVIDENCE && EVIDENCE!=Candidato)
	{
		sprintf (BUFF,"C%d",EVIDENCE);
		cmd=CercaNomeComando (BUFF);
		cmd->BUpDn=1;
		WX11_PrintFlush (cmd);

		sprintf (BUFF,"R%d",EVIDENCE);
		cmd=CercaNomeComando (BUFF);
		cmd->BUpDn=1;
		WX11_PrintFlush (cmd);
		
	}

	if (EVIDENCE)
		SudoNotEvidence ();

	if (!cella->BUpDn)
	{
		EVIDENCE=Candidato;
		EvidenziaCandidati();
	}

	return (0);
}


int SudoListBoxCallBack (CmdInfo *cmd, int Type)
{
	// 
	// ListBox CallBack
	//
	static CmdInfo *cell[25];
	static unsigned int bg[25],fg[25];
	static int last_type=0;

	static int num_cell=0;
	int i,r,c;
	unsigned int newbg,newfg;
	char *p=(cmd)->Label;
	//
	//printf ("SudoListBoxCallBack cmd=%p Type=%d\n",cmd,Type);

	if (Type==LeaveNotify && Type!=last_type)
	{
		for (i=0;i<num_cell;i++)
		{
			r=cell[i]->Name[1]-'0';
			c=cell[i]->Name[2]-'0';

			cell[i]->Bg=bg[i];
			cell[i]->Fg=fg[i];
			
			WX11_ColorBackgroundSet (cell[i], cell[i]->Bg, cell[i]->Bg);
			WX11_PrintFlush(cell[i]);
			if (IsMouseOver (r,c))	SudoCellOver(cell[i], EnterNotify);
		}
		last_type=Type;
		return (0);
		
	}

	if (Type==EnterNotify && Type!=last_type)
	{
		num_cell=0;
		i=0;r=0;c=0;

		newbg=GIALLO;
		newfg=NERO;

		if (!strncmp (p,"    Unset",9))
		{
			newbg=ROSSO;
			newfg=NERO;
		}
		if (!strncmp (p,"  Set",5))
		{
			newbg=GIALLO;
			newfg=NERO;
		}

		while (p[i])
		{

			if (p[i]=='R') 	r=p[i+1]-'0';
			if (p[i]=='C') 	c=p[i+1]-'0';
			if (r && c)
			{
				r--;c--;
				//
				sprintf (BUFF,"X%d%d",r,c);
				cell[num_cell]=CercaNomeComando (BUFF);
				if (cell[num_cell])
				{
					bg[num_cell]=cell[num_cell]->Bg;
					fg[num_cell]=cell[num_cell]->Fg;

					cell[num_cell]->Bg=newbg;
					cell[num_cell]->Fg=newfg;
			

					WX11_ColorBackgroundSet (cell[num_cell], newbg, newbg);
					WX11_PrintFlush(cell[num_cell]);
					if (IsMouseOver (r,c))	SudoCellOver(cell[num_cell], EnterNotify);
					num_cell++;
				}
				r=0;c=0;
			}
			i++;
		}
	}
	last_type=Type;
	//
	return (0);
}
